#!/bin/bash -l

export BIN="../../Src"
export OUTPATH="`pwd`"
export OWSAFETY="nosafe"

	export OUTBASE="dmpc_T30"
	echo $OUTBASE

rm -r $OUTBASE

	$BIN/normalize_data\
		NDATAFORMAT "junk"\
		DATAFILE dmpcT30.dat\
		DATANORMDIM 0
	
	$BIN/set_distribution\
		DISTPARAMS "-2000 12000 50 0.0 1.0 0.05"

	salloc -n 8 -p multinode mpirun $BIN/calc_matrix_mpi\
		DATAFILE $OUTBASE/$OUTBASE.t00.ndata.0\
		DISTFILE $OUTBASE/$OUTBASE.t00.ndist.0\
		PP2PI 128

	STATE=1

	$BIN/initialise_bs_state\
		DATAFILE $OUTBASE/$OUTBASE.t00.ndata.0\
		DISTFILE $OUTBASE/$OUTBASE.t00.ndist.0\
		D2DMFILE $OUTBASE/$OUTBASE.d2dm\
		ETAT $STATE

	salloc -n 8 -p multinode mpirun $BIN/bs_sa_mpi\
		MASSBFILE $OUTBASE/$OUTBASE.t00.bs.1\
		ETAT $STATE\
		ITERT 500\
		MAXSTEP 0.5\
		BOLTZMANN 1E-9\
		INITTEMP 5.0\
		ATTENTEMP 1.002\
		MINTEMP 0.0002
