#include "sidebands.h"
#include "BoltzmannME.h"

int main ( int argc, char *argv[]  ) {

	char (*searchmethods)[7];
	char (*searchfiles)[80];
	int numsearch = (argc - 2)/2;
	searchmethods = new char[numsearch][7];
	searchfiles   = new char[numsearch][80];

	MASSB P(argv[1]);

	char text[100];
	sprintf(text,"Search methods and input files (total %d):\n", numsearch);
	P.update_log(text);

	for (int s=2; s < argc/2+1; s++) {
		strcpy(searchmethods[s-2],argv[2*(s-1)] );
		strcpy(searchfiles[s-2],argv[2*(s-1)+1] );
		sprintf(text,"  %s  %s\n", searchmethods[s-2],searchfiles[s-2]);
		P.update_log(text);
	}

	P.read_data();
	P.find_state();
	if ( strcmp(P.mode,"sim" ) ) {
		P.set_preset();
	}

	if ( !strcmp(P.mode,"fit") ) {	
		for (int s=0; s<numsearch; s++) {
			strcpy(P.searchmethod,searchmethods[s]);
			strcpy(P.searchfile,searchfiles[s]);
			P.etat = s+1;
			BoltzmannME B( P );
			B.lagrange_search( P );
		}
	} else if ( !strcmp(P.mode,"sim") ) {
		P.write_sim();
	} else if ( !strcmp(P.mode,"mix") ) {
		P.write_mix();
		P.write_out();
	}

	cout << "Done." << endl;
	return(0);
}
