#include "cputhreadtime.h"


CPUThreadTime::CPUThreadTime() {
	seconds = time(NULL);
	num_marks = 0;
}

CPUThreadTime::CPUThreadTime( int n ) {
	num_marks = n;
	marks = new clock_t[num_marks];
	wc = new time_t[num_marks];
	marks[0] = clock();
	wc[0] = time(NULL);
	seconds = time(NULL);
	markid = new char[num_marks][120];
	sprintf( markid[0],"Timer Started %30s",ctime(&seconds) );
	maximark = num_marks;
	imark=1;
}

/*int CPUThreadTime::set_threads( int n ) {
	NCPU = omp_get_num_procs();
	if ( n > NCPU ) n = NCPU;
	coreduty = new int[n];
	
	return(0);
}*/

int CPUThreadTime::init( int n ) {
	num_marks = n;
	marks = new clock_t[num_marks];
	wc = new time_t[num_marks];
/*	marks[0] = clock();
	wc[0] = time(NULL);
//	seconds = time(NULL);
	markid = new char[num_marks][120];
	sprintf( markid[0],"Timer Started %30s",ctime(&seconds) );
	maximark = num_marks;
	imark=1;
*/
	return 0;
}


/*int CPUThreadTime::reportstart ( ofstream *lfile ) {
	NCPU = omp_get_num_procs();
	*lfile << "Started: " << markid[0];
	*lfile << "Number of CPUs available: " << NCPU << endl;
	return(0);
}*/

CPUThreadTime::~CPUThreadTime () { 
	if ( num_marks > 0 ) {
		delete[] markid;
		delete marks;
		delete coreduty;	
	}
}

int CPUThreadTime::mark ( ofstream *log, const char * text ) {
	strcpy(markid[imark],text);
	marks[imark] = clock();
	seconds = time(NULL);
	wc[imark++] = seconds;
	*log << "MARK: " << text << ": " << ctime(&seconds) << endl;
	return(imark-1);
}
	

int CPUThreadTime::reportall ( ofstream *lfile ) {
	*lfile << "CPU evolution times (clicks converted to seconds):" << endl;
	*lfile << "                         (elapsed wallclock time):" << endl;
	char otmp[220];
	sprintf(otmp,"%s",markid[0]);
	*lfile << otmp << endl;
	int r=0;
	for ( int m=1; m<maximark; m++ ) {
		if ( !strcmp(markid[m],"") ) break;
		r++;
		sprintf(otmp,"%s: %11.6f s",markid[m],
			double(marks[m]-marks[m-1])/double(CLOCKS_PER_SEC) );
		*lfile << otmp << endl;
		sprintf(otmp,"%s: %11ld s","(elapsed wallclock seconds)",
			wc[m]-wc[m-1]);
		*lfile << otmp << endl;
	}
	seconds = time(NULL);
	*lfile << "Finished: " << ctime(&seconds) << endl;
	*lfile << flush;
	return(r);
}

int CPUThreadTime::report ( ofstream *lfile, int i, int j ) {
	*lfile << "CPU evolution times (clicks converted to seconds) between marks "
		<< i << " and " << j << endl;
	char otmp[220];
	sprintf(otmp,"total: %11.6f s",
		double(marks[j]-marks[i])/double(CLOCKS_PER_SEC) );;
	*lfile << otmp << endl;
	sprintf(otmp,"%s (0 s)",markid[i]);
	*lfile << otmp << endl;
	for ( int m=i+1; m<j; m++ ) {
		if ( !strcmp(markid[i],"") ) break;
		sprintf(otmp,"%s: %11.6f s",markid[i],
			double(marks[i]-marks[i-1])/double(CLOCKS_PER_SEC) );
		*lfile << otmp << endl;
	}
	return(0);
}

int CPUThreadTime::zero_coreduty() {
	for (int p=0; p<NCPU; p++ ) coreduty[p] = 0;
	return(0);
}

/*int CPUThreadTime::incr_coreduty() {
	int tid = omp_get_thread_num();
	coreduty[tid]++;
	return(0);
}*/

int CPUThreadTime::report_coreduty( ofstream *log, int t ) {
	for (int p=0; p<NCPU; p++ ) {
		*log << "Core " << p << " coreduty: " << coreduty[p] << " of "
			<< t << " cycles" << endl;
	}
//	*log << flush;
	return(0);
}

/*int CPUThreadTime::reportthis_coreduty( ofstream *log ) {
	int tid = omp_get_thread_num();
	*log << "Core " << tid << " coreduty: " << coreduty[tid] 
		<< " cycles" << endl;
	return(0);
}*/

int CPUThreadTime::simpletimestamp ( ofstream * log ) {
	seconds = time(NULL);
	*log << "TIME: " << ctime(&seconds);
	return(0);
}
