#include "gp_params.h"
#include "utils.h"


int GPPARAMS::inputpar( char *key, char *val, bool report) {
	char str[256];
	char more[256];
	more[0] = '\0';
	if (! strcmp(key, "PLOTDATAFILE") ) {
		strcpy(plotdatafile,val); 
		sprintf(str,"INPUT MASSBFILE (object.plotdatafile) = %s\n",plotdatafile);
	} else if (! strcmp(key, "PLOTDISTFILE") )	{
		strcpy(plotdistfile,val); 
		sprintf(str,"INPUT PLOTDISTFILE (object.plotdistfile) = %s\n",plotdistfile);
	} else if (! strcmp(key, "DISTFILEROOT") )	{
		strcpy(distfileroot,val); 
		sprintf(str,"INPUT DISTFILEROOT (object.distfileroot) = %s\n",distfileroot);
	} else if (! strcmp(key, "GPFILE") )	{
		strcpy(gpfilename,val); 
		sprintf(str,"INPUT GPFILE (object.gpfilename) = %s\n",gpfilename);
	} else if (! strcmp(key, "RFILE") )	{
		strcpy(Rfilename,val); 
		sprintf(str,"INPUT RFILE (object.Rfilename) = %s\n",Rfilename);
	} else if (! strcmp(key, "MAXINDEX") )	{
		ssf_int( val, &maxindex);
		sprintf(str,"INPUT MAXINDEX (object.maxindex) = %i\n",maxindex);
	} else if (! strcmp(key, "THREADID") )	{
		ssf_int( val, &threadid);
		sprintf(str,"INPUT THREADID (object.threadid) = %i\n",threadid);
	} else if (! strcmp(key, "STATE") )	{
		ssf_int( val, &state);
		sprintf(str,"INPUT THREADID (object.state) = %i\n",state);
	} else if (! strcmp(key, "THREADS") )	{
		ssf_intarray( val, &numthreadstoplot, &threadstoplot);
		sprintf(str,"INPUT THREADS (object.threadstoplot) = %s\n",val);
	} else if (! strcmp(key, "XMIN") )	{
		ssf_double( val, &xmin);
		sprintf(str,"INPUT XMIN (object.xmin) = %f\n",xmin);
	} else if (! strcmp(key, "XMAX") )	{
		ssf_double( val, &xmax);
		sprintf(str,"INPUT XMAX (object.xmax) = %f\n",xmax);
	} else if (! strcmp(key, "XRES") )	{
		ssf_double( val, &xres);
		sprintf(str,"INPUT XRES (object.xres) = %f\n",xres);
	} else if (! strcmp(key, "YMIN") )	{
		ssf_double( val, &ymin);
		sprintf(str,"INPUT YMIN (object.ymin) = %f\n",ymin);
	} else if (! strcmp(key, "YMAX") )	{
		ssf_double( val, &ymax);
		sprintf(str,"INPUT YMAX (object.ymax) = %f\n",ymax);
	} else if (! strcmp(key, "YRES") )	{
		ssf_double( val, &yres);
		sprintf(str,"INPUT YRES (object.yres) = %f\n",yres);
	} else if (! strcmp(key, "SUBSETLABELS") )	{
		ssf_count_stringarray( val, &numsubsets);
		subsetlabels = new char[numsubsets][30];
		ssf_stringarray( val, numsubsets, subsetlabels);
		sprintf(str,"INPUT SUBSETLABELS (object.numsubsets, inferred) = %i\n",numsubsets);
		strcpy(more,"LABELS:\n");
		char tmp[64];
		for (int j=0; j<numsubsets; j++) {
			sprintf(tmp,"  (object.subsetlabels[%i]) = %s\n",j,subsetlabels[j]);
			strcat(more,tmp);
		}
	} else { 
		cerr << "I Don't Recognize " << key << endl;
		exit(0);
	}
	if (report == 0) {
		*lfile << str << flush;
		*lfile << more << flush;
	}
	// or make the above zero, and pass the tid into these functions
	// such that only master writes to lfile. See whether this would 
	// provide economy down the track or whether it's only meaningful
	// here.
	return(0);
}

// may not need this one
int GPPARAMS::parseinputline( string s ) {
	char key[80];
	char val[80];
	sscanf(s.c_str(),"%s %s",key,val);
	inputpar( key, val, 1);
	return(0);
}

	
int GPPARAMS::parseinputs( int c, char *v[] ) {
	char code[256];
	strcpy(code,v[0]);

//	if ( cpuid == 0 ) {	
		*lfile << "***********************\n";
		*lfile << "CODE: " << code << endl;
		simpletimestamp(lfile);
		*lfile << "***********************\n";
//	}
	for (int i=1; i<c; i+=2) {
//		inputpar( v[i], v[i+1], cpuid );
		inputpar( v[i], v[i+1], 0 );
	}
	return(0);
}	
