#include "massb.h"

int main ( int argc, char *argv[]  ) {

	MASSB P;

	int check = 15;
	for (int i=1; i<argc; i+=2) {
		if ( !strcmp(argv[i],"ETAT") ) check -= 8;
		else if ( !strcmp(argv[i],"D2DMFILE") ) check -= 4;
		else if ( !strcmp(argv[i],"DATAFILE" ) ) check -= 2;
		else if ( !strcmp(argv[i],"DISTFILE" ) ) check -= 1;
	}
	if (check != 0) {
		cerr << "[initialize_state] Need to specify:" << endl;
		cerr << "ETAT (state-increment integer)" << endl;
		cerr << "DATAFILE" << endl;
		cerr << "DISTFILE" << endl;
		cerr << "D2DMFILE (the distribution-to-data tranformation matrix file)" << endl;
		exit(0);
	}

	P.append_logfile();
	P.parseinputs( argc, argv );
	P.read_ndata();
	P.read_dist();
	P.read_dist2data_matrix();
	P.write_full_bsetat();

	return(0);
}
