#include "massb.h"

class SA_search {
public:
	SA_search( MASSB& );
	int parseinputs( int, char ** );
	int parseinputline( string );
	int Lagrange_siman( MASSB& );

	// these parameters keep different stages of the search
	// and files written by different processors in parallel
	// threads separate from one another.
	int etat;	// the increment state of the search
	int cpuid;	// any integer, but expected to = thread id
	int sjid;	// any integer, but expected = $SLURM_JOB_ID
	char massbfile[256];
	ofstream *lfile;
	ofstream *dbfile;

private:
	int inputpar( char *, char *, bool);

	ofstream safile;

	// simulated annealing parameters
	double mintemp;		// temperature below which simulated annealing stops
	double inittemp;	// initial high temperature
	double maxstep;		// maximum step size for any one lagrange multiplier
	double boltzmann;	// the boltzmann constant used in determination of
						// step selection
	double attentemp;	// the factor used to attenuate the temp between steps
	int iterT;			// the number of random steps taken at each temperature

	// monte carlo/simulated annealing parameters and MC statistical structures
	int erriterT, permcblock, maxmcblocks;
	double errmaxstep, errboltzmann, errinittemp, errattentemp; 
	double errmintemp, minstdev2, maxmcrmsd;

	// MC error statistics
    gsl_vector *mcavg;
    gsl_vector *mcavgerr;
    gsl_vector *mcstdev;
    gsl_vector *mcstdeverr;
};
