#!/usr/local/bin/python3.3

import sys, getopt, os.path, subprocess
import re
import numpy as npy

class Obj:
   def __init__(self):
      pass

def main(argv):
# specify the data file (-f) on the command line
   data = ''
   try:
      opts, args = getopt.getopt(argv,"ho:",["output="])
   except getopt.GetoptError:
      print('sblm_ps.py -o <output> .data-files')
      sys.exit(2)
   for opt, arg in opts:
      if (opt == '-h' or len(argv) < 3):
         print('sblm_ps.py -o <output> .data-files')
         sys.exit()
      elif opt in ("-o", "--output"):
         output = arg
      else:
         print('usage: sblm_ps.py -o <output> .data-files')
         
   print("output = ", output)

   datafiles = argv[2:]
   
   for d in datafiles:
      print(d)
   
   dat = open(datafiles[0],'r',8192)
   tmp = dat.readline()
   tmp = dat.readline()
   tmp = dat.readline()
   speeds = []
   for line in dat:
      d = [float(x) for x in line.split()]
      speeds.append(d[0])
   dat.close()
   
   speeds = npy.asarray(speeds)
   speeds = npy.unique(speeds)
   print("SPEEDS: ", speeds)
     
#   instance = Obj( );

   numsubsets = len(speeds)
   maxindex = numsubsets * len(datafiles)

   gpname = output+".gp"
   gp = open( gpname,'w')
   
   epsname = output+".eps"
   
   interval = 0.4 / ( len(datafiles) - 1)
   offset = -0.2

   print("set term postscript eps enhanced color solid size 10cm,{:.1f}cm".format(6*numsubsets+3), file = gp )
   print("set out \'{:}\'".format(epsname), file = gp)
   print("set style line 1 lt 1 lc rgb \"black\" lw 2", file = gp)
   print("set style line 1 lt 2 lc rgb \"red\" lw 2", file = gp)
   print("set style line 1 lt 3 lc rgb \"blue\" lw 2 ps 1 pt 6", file = gp)
   print("set style line 1 lt 4 lc rgb \"blue\" lw 1 pt 1", file = gp)
   print("set style line 1 lt 5 lc rgb \"black\" lw 0.5", file = gp)
   print("set tmargin 1", file = gp)
   print("set rmargin 1.5", file = gp)
   print("set lmargin 5", file = gp)
   print("set mxtics", file = gp)
   print("set multiplot layout {:d}, 1".format(2 * numsubsets), file = gp)
#   print("set yrange [0:*]", file = gp)
#   print("set xrange [*:*] reverse", file = gp)
   print("set bar 8", file = gp)
   for s in speeds:
      print("set yrange [0:*]", file = gp)
      print("set xrange [*:*] reverse", file = gp)
      print("set label 1 \"MAS = {:}\" at graph 0.05,0.9".format(s), file = gp)
      # Sideband plots
      str = "plot \'{:}\' u 2:( abs($1 - {:}) < 1E-6 ? $3 : 1/0):"\
            +"( abs($1 - {:}) < 1E6 ? $4 : 1/0) w yerr ls 3 not"
      print(str.format(datafiles[0], s, s), end = '', file = gp)
      
      for i, d in enumerate(datafiles):
         off = offset + i * interval
         print(",\\", file = gp)
         print("  \'{:}\' u ($2+{:.3f}):(abs($1-{:}) < 1E-6 ? $5+$6 : 1/0) w imp ls 3 not".format(d,off,s), end = '', file = gp)
      print("", file = gp)
      
      print("set yrange [*:*]", file = gp)
#		// lagrange multiplier plots
      print("plot 0 ls 5 not", end = '', file = gp)
      for i, d in enumerate(datafiles):
         off = offset + i * interval
         print(",\\", file = gp)
         print("  \'{:}\' u ($2+{:.3f}):(abs($1 - {:}) < 1E-6 ? $8 : 1/0) w imp ls 2 not".format(d,off,s), end = '', file = gp)
      print("", file = gp)

   gp.close();
   
   subprocess.call(["gnuplot", gpname])


   
if __name__ == "__main__":
   main(sys.argv[1:])


