/*	
numsubsets	Copyright (c) 2010 J.D. Gehman, Melbourne Australia

    This file is part of XYZ

    XYZ is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    XYZ is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef UTILS_INCLUDED_
#define UTILS_INCLUDED_

#include <fstream>
#include <iomanip>
#include <cstdlib>
#include <unistd.h>
#include <cstring>
#include <cmath>
#include <ctime>
#include <iostream>
#include <gsl/gsl_vector.h>
#include <gsl/gsl_blas.h>
#include <gsl/gsl_math.h>
#include <gsl/gsl_linalg.h>
#include <gsl/gsl_errno.h>

//#ifdef OPENMP
//#include <omp.h>
//#endif
using namespace std;


int iscomment (string);
void DEBUG( int );
double gvg(const gsl_vector *, int);
void gvs(gsl_vector *, int, double);
double gmg(const gsl_matrix *, int, int);
void gms(gsl_matrix *, int, int, double);
int report_array(const gsl_vector *, int);
int ssf_doublearray( char [], int *, double **);
int ssf_intarray( char [], int *, int **);
int ssf_count_stringarray( char [], int * );
int ssf_stringarray( char [], int , char (*)[30] );
int ssf_double( char *, double * );
int ssf_int( char *, int * );
int gen_random_seed (int );
int simpletimestamp ( ofstream * log );
int gvf ( gsl_vector *, double (*)(double) );
int gmf ( gsl_matrix *, double (*)(double) );
double vsquare (double);
double vsqrt (double);
double vatan (double);
double vinvert (double);
int index_of_closest_value( const gsl_vector *, double );
void gvpe(gsl_vector *, int, double);
void gmpe(gsl_matrix *, int, int, double);
double var ( const double, const double, const int );
double covar ( const double, const double, const double, const int );

#endif
