#ifndef VECTORSTATS_INCLUDED_
#define VECTORSTATS_INCLUDED_
#endif 

#include <fstream>
#include <iomanip>
#include <cstdlib>
#include <cmath>
#include <iostream>
#include <gsl/gsl_vector.h>
#include <gsl/gsl_blas.h>
#include <gsl/gsl_math.h>
#include <gsl/gsl_linalg.h>
#include <gsl/gsl_multifit_nlin.h>
using namespace std;

class vector_stats {
	public:
	vector_stats();
	vector_stats( const gsl_vector *, int );
	vector_stats( const gsl_vector *, const gsl_vector *, int );
	void first_moment_analysis( const gsl_vector *, const gsl_vector *);
	~vector_stats();
	double mean;
	double stdev;
	gsl_vector * K;
	int n;
	double sum, sumsq;

	double mean2;
	double stdev2;
	gsl_vector * K2;
	double sum2, sumsq2;

	double crosscorrcoeff;
	double first_moment;
	int first_moment_i;
};
